//+------------------------------------------------------------------+
//|                                                    Maxima88x.mq4 |
//|                                                     TAR Software |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "TAR Software"

enum buysell
{
    buy,
    sell
};
enum pointsprice
{
   points,
   price
};
extern string g = "+++ Enter your CHART GMT offset +++";
extern string h = "+++ Will calculate GMT hour as ChartHour+GMTOffset +++";
extern int GMTOffset = -1;
extern string q = "+++ Set points or price +++";
extern pointsprice PriceOrPoints = points;
extern double PriceOrPointsValue = 0;
extern buysell BuyOrSell = buy;
extern string d = "+++ Set stop loss/take profit in points +++";
extern int StopLossPoints = 0;
extern int TakeProfitPoints = 0;
extern string j = "+++ Number of lots to open +++";
extern double Lots = 0.1;
extern string z = "+++ Use automatic risk percentage lot adjustment +++";
extern bool AutoLot = false;
extern double EquityRiskPercentage = 0.01;
extern string w = "+++ Time Order/stop +++";
extern string OpenTime = "00:00:00";
extern string CloseTime = "23:30:00";

datetime prevTime;
bool dayPassed = true;
int OpenSell = -1;
int OpenBuy = -1;
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   
   datetime time = iTime(NULL,PERIOD_H1,0);
   
   
   int heuresOpen = StringSubstr(OpenTime, 0, 2)+GMTOffset;
   int minutesOpen = StringSubstr(OpenTime, 3, 2);
   int secondesOpen = StringSubstr(OpenTime, 6, 2);
   
   if (heuresOpen < 0) heuresOpen = heuresOpen + 24;
   if (heuresOpen >= 24) heuresOpen = heuresOpen - 24;


   if (TimeDay(prevTime)< TimeDay(time))
   {
      dayPassed = true;
      
   }

         
   if (dayPassed == true && OpenSell == -1 && OpenBuy == -1 && TimeHour(time) >= heuresOpen && TimeMinute(time) >= minutesOpen && TimeSeconds(time) >= secondesOpen)
   {
   

      if (PriceOrPoints == points)
      {
         if (BuyOrSell == buy)
            PriceOrPointsValue = Bid+PriceOrPointsValue*Point;
         else
            PriceOrPointsValue = Ask+PriceOrPointsValue*Point;
      }
      
      //calculate lots
      double spread = Ask-Bid;
      if (AutoLot && EquityRiskPercentage < 1 && EquityRiskPercentage > 0)
      {
         Lots = (AccountEquity()*EquityRiskPercentage)/StopLossPoints;
      }
      
      if (BuyOrSell == buy)
      {
         double p1 = PriceOrPointsValue+spread;
         p1 = int(p1 * 10000)/10000.;


         OpenBuy = OrderSend(Symbol(), OP_BUYSTOP, Lots, p1, 3, PriceOrPointsValue-StopLossPoints*Point*2+spread
                                       ,PriceOrPointsValue+TakeProfitPoints*Point+spread,"woohoo",8675309,
                                       time+3600*1,Green);
                   
                   
      }
      else
      { 
         double p2 = PriceOrPointsValue;
         p2 = int(p2 * 10000)/10000.;
         OpenSell = OrderSend(Symbol(), OP_SELLSTOP, Lots, p2, 3, PriceOrPointsValue+StopLossPoints*Point-spread,
                                       PriceOrPointsValue-TakeProfitPoints*Point-spread,"woohooooo",8675309,
                                       time+3600*1,Green);  
    
      }                 
   }
   

   
  
   int heuresClose = StringSubstr(CloseTime, 0, 2);
   int minutesClose = StringSubstr(CloseTime, 3, 2);
   int secondesClose = StringSubstr(CloseTime, 6, 2);
   
   int maxDuration = (heuresClose-heuresOpen)*3600 + (minutesClose - minutesOpen) * 60 + (secondesClose - secondesOpen);
   
   for(int pos = OrdersTotal()-1; pos >= 0 ; pos--) if (
       OrderSelect(pos, SELECT_BY_POS)            // Only my orders w/
   &&  OrderMagicNumber() == 8675309         // my magic number
   &&  OrderSymbol()      == Symbol() ){               // and period and symbol
       int duration = TimeCurrent() - OrderOpenTime();
       if (duration >= maxDuration)
       {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 3*1);
            OpenSell = -1;
            OpenBuy = -1;   
            
            dayPassed = false;                  
       }
   }
   
   prevTime = time;
   
   return(0);
}
//+------------------------------------------------------------------+